import { ButtonProps as GrommetButtonProps } from 'grommet';
import * as React from 'react';
import { Coloring, DefaultProps, Omit, RenditionSystemProps, ResponsiveStyle, Sizing, Theme } from '../common-types';
interface ButtonBaseProps extends Coloring, Sizing {
    width?: ResponsiveStyle;
    bg?: string;
    outline?: boolean;
    underline?: boolean;
    light?: boolean;
}
export interface InternalButtonProps extends ButtonBaseProps, Omit<DefaultProps, 'onClick'>, GrommetButtonProps {
    type?: 'submit' | 'reset' | 'button';
    label?: 'string' | JSX.Element;
}
export declare type ButtonProps = InternalButtonProps & RenditionSystemProps;
export interface ThemedButtonProps extends ButtonProps {
    theme: Theme;
}
declare const _default: React.FunctionComponent<ButtonProps>;
export default _default;
