/// <reference types="react" />
import { JSONSchema6 } from 'json-schema';
import { DataTypeEditProps } from '../Filters';
export declare const operators: {
    is: {
        getLabel: (_s: JSONSchema6) => string;
    };
    is_before: {
        getLabel: (_s: JSONSchema6) => string;
    };
    is_after: {
        getLabel: (_s: JSONSchema6) => string;
    };
};
declare type OperatorSlug = keyof typeof operators;
interface DateTimeFilter extends JSONSchema6 {
    title: OperatorSlug;
    properties?: {
        [k: string]: {
            type: 'string';
            format: 'date-time';
            const: string;
            formatMaximum?: string;
            formatMinimum?: string;
        };
    };
}
export declare const decodeFilter: (filter: DateTimeFilter) => {
    field: string;
    operator: "is" | "is_before" | "is_after";
    value: string;
} | null;
export declare const createFilter: (field: string, operator: "is" | "is_before" | "is_after", value: any, schema: JSONSchema6) => DateTimeFilter;
export declare const Edit: ({ value, onUpdate, ...props }: DataTypeEditProps & import("../Input").InternalInputProps & import("../..").Tooltip & import("../..").StyledSystemProps & {
    slim?: boolean | undefined;
}) => JSX.Element;
export {};
