/// <reference types="react" />
import { JSONSchema6 } from 'json-schema';
import { DataTypeEditProps } from '../Filters';
export declare const operators: {
    is: {
        getLabel: (_s: JSONSchema6) => string;
    };
    is_not: {
        getLabel: (_s: JSONSchema6) => string;
    };
};
declare type OperatorSlug = keyof typeof operators;
interface EnumFilter extends JSONSchema6 {
    title: OperatorSlug;
    properties?: {
        [k: string]: {
            const?: any;
            not?: {
                const?: any;
            };
        };
    };
}
export declare const decodeFilter: (filter: EnumFilter) => {
    field: string;
    operator: "is" | "is_not";
    value: any;
} | null;
export declare const createFilter: (field: string, operator: "is" | "is_not", value: any, schema: JSONSchema6) => EnumFilter;
export declare const Edit: ({ schema, value, onUpdate, ...props }: DataTypeEditProps & import("../Select").InternalSelectProps & import("../..").Tooltip & import("../..").StyledSystemProps & {
    slim?: boolean | undefined;
}) => JSX.Element;
export {};
