"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var mermaid_1 = require("mermaid");
var React = require("react");
var uuid = require("uuid/v4");
var Grid_1 = require("../components/Grid");
var Mermaid = (function (_super) {
    __extends(Mermaid, _super);
    function Mermaid(props) {
        var _this = _super.call(this, props) || this;
        _this.id = "rendition-mermaid-" + uuid();
        return _this;
    }
    Mermaid.prototype.componentDidMount = function () {
        this.renderSVG();
    };
    Mermaid.prototype.renderSVG = function () {
        var value = this.props.value;
        var renderArea = this.renderArea;
        if (!renderArea || !value) {
            return;
        }
        try {
            mermaid_1.mermaidAPI.render(this.id, value, function (svgCode, bindFunctions) {
                renderArea.innerHTML = svgCode;
                bindFunctions(renderArea);
            });
        }
        catch (error) {
            renderArea.innerHTML = "Unable to parse input: " + error.message;
        }
    };
    Mermaid.prototype.componentDidUpdate = function (prevProps) {
        if (prevProps.value !== this.props.value) {
            this.renderSVG();
        }
    };
    Mermaid.prototype.render = function () {
        var _this = this;
        var _a = this.props, value = _a.value, props = __rest(_a, ["value"]);
        return (React.createElement(Grid_1.Box, __assign({}, props),
            React.createElement("div", { ref: function (element) { return (_this.renderArea = element); } })));
    };
    return Mermaid;
}(React.Component));
exports.Mermaid = Mermaid;
