export declare const breakpoints: string[];
export declare const space: number[];
export declare const fontSizes: number[];
export declare const weights: number[];
export declare const radius = 3;
export declare const font = "'Nunito', Arial, sans-serif";
export declare const titleFont = "CircularStd, Arial, sans-serif";
export declare const monospace = "'Ubuntu Mono', 'Courier New', monospace";
declare const _default: {
    breakpoints: string[];
    space: number[];
    fontSizes: number[];
    weights: number[];
    font: string;
    titleFont: string;
    monospace: string;
    colors: {
        primary: {
            main: string;
            light: string;
            dark: string;
        };
        secondary: {
            main: string;
            light: string;
            dark: string;
        };
        tertiary: {
            main: string;
            light: string;
            dark: string;
        };
        quartenary: {
            main: string;
            light: string;
            dark: string;
        };
        danger: {
            main: string;
            semilight: string;
            light: string;
            dark: string;
        };
        warning: {
            main: string;
            semilight: string;
            light: string;
            dark: string;
        };
        success: {
            main: string;
            semilight: string;
            light: string;
            dark: string;
        };
        info: {
            main: string;
            semilight: string;
            light: string;
            dark: string;
        };
        text: {
            main: string;
            light: string;
            dark: string;
        };
        statusIdle: {
            main: string;
        };
        statusConfiguring: {
            main: string;
        };
        statusUpdating: {
            main: string;
        };
        statusPostProvisioning: {
            main: string;
        };
        statusOffline: {
            main: string;
        };
        statusInactive: {
            main: string;
        };
        gray: {
            main: string;
            light: string;
            dark: string;
        };
    };
    radius: number;
    global: {
        font: {
            family: string;
            size: string;
            height: number;
        };
        control: {
            disabled: {
                opacity: number;
            };
            border: {
                radius: string;
            };
        };
        colors: {
            focus: string;
        };
    };
    button: {
        border: {
            width: string;
            radius: string;
            color: string;
        };
        padding: {
            horizontal: string;
        };
    };
    layer: {
        container: {
            zIndex: number;
        };
        zIndex: number;
    };
    text: {
        medium: {
            size: string;
            height: string;
        };
    };
    tab: {
        extend: string;
        color: string;
    };
};
export default _default;
